mlpack_range_search(1)

NAME
mlpack_range_search - range search

SYNOPSIS
 mlpack_range_search [-m unknown] [-l int] [-U double] [-L double] [-N bool] [-q unknown] [-R bool] [-r unknown] [-s int] [-S bool] [-t string] [-V bool] [-d string] [-n string] [-M unknown] [-h -v]

DESCRIPTION

This program implements range search with a Euclidean distance metric. For a given query point, a given range, and a given set of reference points, the program will return all of the reference points with distance to the query point in the given range. This is performed for an entire set of query points. You may specify a separate set of reference and query points, or only a reference set -- which is then used as both the reference and query set. The given range is taken to be inclusive (that is, points with a distance exactly equal to the minimum and maximum of the range are included in the results).

For example, the following will calculate the points within the range `[2, 5]` of each point in 'input.csv' and store the distances in'distances.csv' and the neighbors in 'neighbors.csv'

$ mlpack_range_search --min 2 --max 5 --distances_file input --distances_file distances --neighbors_file neighbors

The output files are organized such that line i corresponds to the points found for query point i. Because sometimes 0 points may be found in the given range, lines of the output files may be empty. The points are not ordered in any specific manner.

Because the number of points returned for each query point may differ, the resultant CSV-like files may not be loadable by many programs. However, at this time a better way to store this non-square result is not known. As a result, any output files will be written as CSVs in this manner, regardless of the given extension.

OPTIONAL INPUT OPTIONS

--help (-h) [bool]
    Default help info.

--info [string]
    Print help on a specific option. Default value ''.

--input_model_file (-m) [unknown]
    File containing pre-trained range search model.

--leaf_size (-l) [int]
    Leaf size for tree building (used for kd-trees, vp trees, random projection trees, UB trees, R trees, R* trees, X trees, Hilbert R trees, R+ trees, R++ trees, and octrees). Default value 20.

--max (-U) [double]
    Upper bound in range (if not specified, +inf will be used. Default value 0.

--min (-L) [double]
    Lower bound in range. Default value 0.

--naive (-N) [bool]
    If true, O(n^2) naive mode is used for computation.

--query_file (-q) [unknown]
    File containing query points (optional).

--random_basis (-R) [bool]
    Before tree-building, project the data onto a random orthogonal basis.

--reference_file (-r) [unknown]
    Matrix containing the reference dataset.

--seed (-s) [int]
    Random seed (if 0, std::time(NULL) is used). Default value 0.

--single_mode (-S) [bool]
    If true, single-tree search is used (as opposed to dual-tree search).

--tree_type (-t) [string]
    Type of tree to use: 'kd', 'vp', 'rp', 'max-rp', 'ub', 'cover', 'r', 'r-star', 'x', 'ball', 'hilbert-r', 'r-plus', 'r-plus-plus', 'oct'. Default value 'kd'.

--verbose (-v) [bool]
    Display informational messages and the full list of parameters and timers at the end of execution.

--version (-V) [bool]
    Display the version of mlpack.

OPTIONAL OUTPUT OPTIONS

--distances_file (-d) [string]
    File to output distances into. Default value ''.

--neighbors_file (-n) [string]
    File to output neighbors into. Default value ''.

--output_model_file (-M) [unknown]
    If specified, the range search model will be saved to the given file.

ADDITIONAL INFORMATION

For further information, including relevant papers, citations, and theory, consult the documentation found at http://www.mlpack.org or included with your distribution of mlpack.